package de.tudresden.inf.st.mquat.solving.genetic.opt4j;

import de.tudresden.inf.st.mquat.jastadd.model.Solution;
import org.opt4j.core.Objective.Sign;
import org.opt4j.core.Objectives;
import org.opt4j.core.problem.Evaluator;

public class Opt4jEvaluator implements Evaluator<Solution> {

  @Override
  public Objectives evaluate(Solution phenotype) {
    Objectives objectives = new Objectives();
    objectives.add("Validity Errors", Sign.MIN, phenotype.evaluateValidity() * 1000);
    objectives.add("Software Validity Errors", Sign.MIN, phenotype.evaluateSoftwareValidity() * 1000);
    objectives.add("Structural Errors", Sign.MIN, phenotype.evaluateSoftwareCompleteness() * 1000);

    double objective = phenotype.computeObjective();

    if (phenotype.evaluateValidity() != 0) {
      objective *= 10;
    }
    if (phenotype.evaluateSoftwareValidity() != 0) {
      objective *= 10;
    }
    if (phenotype.evaluateSoftwareCompleteness() != 0) {
      objective *= 10;
    }

    objectives.add("Energy", Sign.MIN, objective);

    return objectives;
  }

}
